from vcCommand import *
from vcHelpers.Application import *
global diags
app = getApplication()
sim = app.Simulation
diags = []
listeners = []
selManager = app.SelectionManager

def showJoints(c):
  global joints, diags, listeners

  joints = []
  d = None
  listener = EventListener(c)
  diags.append( [c, d, joints, listener] )
  diags[-1][1] = getDialog( Caption = c.Name + ': Joint Values')
  diags[-1][3].Diag = diags[-1][1]
  contrls = c.findBehavioursByType(VC_SERVOCONTROLLER)  + c.findBehavioursByType(VC_ROBOTCONTROLLER) 
  run = 0
  for i in contrls:
    for j in i.Joints:
      run += 1
      jProp = listener.Component.getProperty(j.Name)
      if jProp != None:
        diags[-1][2].append(jProp)
        diags[-1][2][-1].OnChanged = diags[-1][3].updateDialogValue
        p = diags[-1][1].addProperty(jProp.Name, VC_REAL, diags[-1][3].updateRobot)
        p.Group = run
        p.Value = jProp.Value
        listener.Joints.append(jProp)
      else:
	    if listener.Component.Parent.Component:
			jProp = listener.Component.Parent.Component.getProperty(j.Name)
			if jProp != None:
			  diags[-1][2].append(jProp)
			  diags[-1][2][-1].OnChanged = diags[-1][3].updateDialogValue
			  p = diags[-1][1].addProperty(jProp.Name, VC_REAL, diags[-1][3].updateRobot)
			  p.Group = run
			  p.Value = jProp.Value
			  listener.Joints.append(jProp)
  listener.Diag = diags[-1][1]
  if run < 1:
    deleteDiag(c)
    print 'Selected device, "'+c.Name+'", has no kinematic joints.'
  else:
    diags[-1][1].show()

def selectedComp(s):
  if selManager.getSelection(VC_SELECTION_COMPONENT):
    c = selManager.getSelection(VC_SELECTION_COMPONENT)[0]
    showJoints(c)

def first_state():
  global diags
  diags = []

  for c in selManager.getSelection(VC_SELECTION_COMPONENT):
    showJoints(c)



def deleteDiag(c):
  global diags
  for x in diags:
    if x[0] == c:
      break
  else:
    x = None
  if x:
    x[1].destroyWindow()
    diags.remove( x )



class EventListener:
  # Event listener to get handle to owner component from triggering property
  def __init__(self, icomp):
    self.Component = icomp
    self.Joints = []
    self.Diag = None
  def updateDialogValue(self, arg):
    self.Diag.getProperty(arg.Name).Value = arg.Value
  def updateRobot(self, arg):
    if not sim.IsRunning:
      if self.Component.getProperty(arg.Name) != None:
        self.Component.getProperty(arg.Name).Value = arg.Value
        app.render()
      elif self.Component.Parent.Component.getProperty(arg.Name) != None:
        self.Component.Parent.Component.getProperty(arg.Name).Value = arg.Value
        app.render()
      else:
        print "Eigenschaft nicht gefunden. Konnte nicht gesetzt werden"

app.OnComponentRemoved = deleteDiag
addState( first_state )